#ifndef OGIEN
////////////////////////////////////////////////////////////////////////
//
// modul do symulacji eksplozji
//
//	by Pawel Biernacki
//
//	Aachen, 12.1997
//
////////////////////////////////////////////////////////////////////////

#define OGIEN
#define KOLO 72
#define PROMIEN 32

// uzycie :
// wspolny obiekt typu "symulator eksplozji" i dla kazdej eksplozji
// obiekt "wybuch"

// parametry : grawitacja, atmosfera (opor), eksplozja (predkosc poczatkowa)

// dla wybuchu : natezenie poczatkowe, natezenie minimalne





class wybuch
{
public:
int natezenie,jeszcze;

unsigned char temperatura[KOLO*PROMIEN];
void wyczysc(void);
void zapal(void);

wybuch(void) { natezenie=0; wyczysc(); jeszcze=0; }
wybuch(int nat): natezenie(nat) { wyczysc(); jeszcze=PROMIEN; }
void inicjuj(int n) { natezenie=n; jeszcze=PROMIEN; }
int skonczony(void) { return jeszcze==0; }
};




class symulator_eksplozji
{
private:
unsigned do_mapy[KOLO*PROMIEN];
unsigned skok[KOLO*PROMIEN];

public:
unsigned char mapa[2*PROMIEN*2*PROMIEN];
int pozycja; // do obrotu

// obracanie : przez funkcje "obrot" lub bezposrednie przypisanie wartosci
// zmiennej "pozycja"
void obrot(int k);


symulator_eksplozji(float grawitacja=0.1,float atmosfera=0.0,float eksplozja=1.0);
void symulacja(wybuch &);
};




#endif